<template>
  <div>
    <div v-if="loadingEntry">
      <v-skeleton-loader
        class="mx-auto"
        type="table-heading, image, image, image, table-tfoot"
      />
    </div>
    <div v-if="!loadingEntry">
      <v-row class="bg">
        <v-col class="patient-class">
          <div class="agora-video">
            <StreamPlayer v-if="localStream" :stream="localStream" :domId="localStream.getId()" />
          </div>
        </v-col>
        <v-col style="min-height: 70vh">
          <div v-for="(remoteStream, index) in remoteStreams" :key="index" class="agora-video">
            <StreamPlayer :stream="remoteStream" :domId="remoteStream.getId()" />
          </div>
        </v-col>
      </v-row>
      <v-row class="bg">
        <v-col class="name-class">
          <div class="name-align">
            <v-text-field
              v-if="!user.userType"
              solo
              dense
              rounded
              readonly
              :value="'Paciente: ' + appointmentInfo.patientName"
            />
            <v-text-field
              v-if="user.userType"
              solo
              dense
              rounded
              readonly
              :value="'Especialista: ' + appointmentInfo.specialistName"
            />
          </div>
        </v-col>
        <v-col class="name-class">
          <div class="name-align">
            <v-text-field
              v-if="user.userType"
              solo
              dense
              rounded
              readonly
              :value="'Paciente: ' + appointmentInfo.patientName"
            />
            <v-text-field
              v-if="!user.userType"
              solo
              dense
              rounded
              readonly
              :value="'Especialista: ' + appointmentInfo.specialistName"
            />
          </div>
        </v-col>
      </v-row>
      <v-footer
        min-height="100px"
        height="110vh"
        fixed
        elevation="24"
      >
        <v-row>
          <v-col>
            <v-btn
              x-large
              depressed
              class="mx-3"
              @click="dialogAppointmentInfo = true"
            >
              Detalle de la Cita
            </v-btn>
          </v-col>
          <v-col>
            <div
              class="d-flex justify-center"
            >
              <v-btn
                v-if="!muteAudioBool"
                class="mx-2"
                fab
                color="white"
                :disabled="!disableJoin"
                @click="muteAudio"
              >
                <v-icon>
                  mdi-microphone
                </v-icon>
              </v-btn>
              <v-btn
                v-if="muteAudioBool"
                class="mx-2"
                fab
                color="white"
                :disabled="!disableJoin"
                @click="unmuteAudio"
              >
                <v-icon color="red">
                  mdi-microphone-off
                </v-icon>
              </v-btn>
              <v-btn
                v-if="!muteVideoBool"
                class="mx-2"
                fab
                color="white"
                :disabled="!disableJoin"
                @click="muteVideo"
              >
                <v-icon>
                  mdi-video
                </v-icon>
              </v-btn>
              <v-btn
                v-if="muteVideoBool"
                class="mx-2"
                fab
                color="white"
                :disabled="!disableJoin"
                @click="unmuteVideo"
              >
                <v-icon color="red">
                  mdi-video-off
                </v-icon>
              </v-btn>
            </div>
          </v-col>
          <v-col>
            <div
              class="d-flex justify-end"
            >
              <v-btn
                v-if="!disableJoin"
                x-large
                color="primary"
                class="mx-3"
                @click="dialogPreVideoCall = true"
              >
                Ingresar
              </v-btn>
              <v-btn
                v-if="disableJoin"
                x-large
                color="error"
                class="mx-3"
                @click="leaveEvent"
              >
                Salir
              </v-btn>
              <v-btn
                v-if="disableJoin && !disableRecording && user.userType"
                x-large
                color="primary"
                class="mx-3"
                :loading="loadingBtnRecording"
                @click="startVideoRecording"
              >
                Empezar Grabación
              </v-btn>
              <v-btn
                v-if="disableJoin && disableRecording && user.userType"
                x-large
                color="primary"
                class="mx-3"
                :loading="loadginBtnStopRecording"
                @click="stopVideoRecording"
              >
                Detener Grabación
              </v-btn>
            </div>
          </v-col>
        </v-row>
      </v-footer>
      <v-dialog
        v-model="dialogPreVideoCall"
        width="590"
      >
        <v-card>
          <v-card-title class="text-h5 grey lighten-2">
            Todo listo para unirte?
          </v-card-title>
          <v-card-text class="bg-pre-video">
            <v-col class="d-flex justify-center">
              <v-sheet elevation="20" class="pre-sheet">
                <div class="d-flex justify-center">
                  <video id="video" class="pre-video" />
                </div>
              </v-sheet>
            </v-col>
            <div
              class="d-flex justify-center"
            >
              <v-btn
                v-if="!preMuteAudioBool"
                class="mx-2"
                fab
                color="white"
                @click="preMuteAudio"
              >
                <v-icon>
                  mdi-microphone
                </v-icon>
              </v-btn>
              <v-btn
                v-if="preMuteAudioBool"
                class="mx-2"
                fab
                color="white"
                @click="preUnmuteAudio"
              >
                <v-icon color="red">
                  mdi-microphone-off
                </v-icon>
              </v-btn>
              <v-btn
                v-if="!preMuteVideoBool"
                class="mx-2"
                fab
                color="white"
                @click="preMuteVideo"
              >
                <v-icon>
                  mdi-video
                </v-icon>
              </v-btn>
              <v-btn
                v-if="preMuteVideoBool"
                class="mx-2"
                fab
                color="white"
                @click="preUnmuteVideo"
              >
                <v-icon color="red">
                  mdi-video-off
                </v-icon>
              </v-btn>
            </div>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <v-spacer />
            <v-btn
              color="primary"
              text
              x-large
              :loading="loadingBtnJoin"
              @click="joinEvent"
            >
              Ingresar
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog
        v-model="dialogAppointmentInfo"
        width="500"
      >
        <v-card>
          <v-card-title class="text-h5 grey lighten-2">
            Información de la cita
          </v-card-title>
          <v-card-text>
            <v-container fluid>
              <v-row>
                <v-col cols="4">
                  <v-subheader
                    class="mt-2 mb-5"
                  >
                    Fecha cita:
                  </v-subheader>
                  <v-subheader
                    class="mt-5 mb-5 pt-1"
                  >
                    Hora inicio:
                  </v-subheader>
                  <v-subheader
                    class="mt-5 mb-5 pt-2"
                  >
                    Hora Fin:
                  </v-subheader>
                </v-col>
                <v-col cols="8">
                  <v-text-field
                    :value="appointmentInfo.date"
                    readonly
                  />
                  <v-text-field
                    :value="appointmentInfo.initHourAp"
                    readonly
                  />
                  <v-text-field
                    :value="appointmentInfo.endHourAp"
                    readonly
                  />
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <v-spacer />
            <v-btn
              color="primary"
              text
              @click="dialogAppointmentInfo = false"
            >
              Cerrar
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog
        v-model="dialogPoll"
        persistent
        max-width="290"
      >
        <v-card>
          <v-card-title class="text-h5">
            Gracias por unirte a la cita
          </v-card-title>
          <v-card-text>Para poder brindarte un servicio de calidad, nos ayudaría mucho si contestas la siguiente encuesta.</v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn
              color="primary"
              text
              @click="openPollPacient"
            >
              Aceptar
            </v-btn>
            <v-btn
              color="primary"
              text
              @click="dialogPoll = false"
            >
              Cerrar
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-snackbar
        v-model="snackBar.show"
        :color="snackBar.color"
        text
        top
      >
        {{ snackBar.text }}
        <template #action="{ attrs }">
          <v-btn
            color="blue"
            text
            v-bind="attrs"
            @click="snackBar.show = false">
            <v-icon>mdi-window-close</v-icon>
          </v-btn>
        </template>
      </v-snackbar>
    </div>
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import axios from 'axios';
import StreamPlayer from '~/components/streamPlayer.vue';
import { log } from '~/assets/utils.js';

export default {
  components: {
    StreamPlayer,
  },
  validate({ params }) {
    return params.channelName.length === 12;
  },
  data() {
    return {
      disableJoin: false,
      disableRecording: false,
      localStream: null,
      remoteStreams: [],
      queryInterval: null,
      queryIntervalMix: null,
      muteAudioBool: false,
      muteVideoBool: false,
      preMuteAudioBool: false,
      preMuteVideoBool: false,
      loadingBtnJoin: false,
      loadingBtnRecording: false,
      loadginBtnStopRecording: false,
      loadingPreVideoCall: false,
      dialogPreVideoCall: true,
      dialogAppointmentInfo: false,
      dialogPoll: false,
      loopTimeMs: 2000,
      snackBar: {
        show: false,
        color: '',
        text: '',
      },
    };
  },
  computed: {
    ...mapState({
      user: state => state.videocalling.user,
      option: state => state.videocalling.option,
      optionRecorder: state => state.videocalling.optionRecorder,
      appointmentInfo: state => state.videocalling.appointmentInfo,
      s3BucketInfo: state => state.videocalling.s3BucketInfo,
      loadingEntry: state => state.videocalling.loadingEntry,
    }),
  },
  async mounted() {
    await this.setChannel({ channelName: this.$route.params.channelName });
    await this.setUserInformation();
    await this.enterVideoCallService({ agoraName: this.option.channel, userType: this.user.userType, userUUID: this.user.userUUID, token: this.user.token });
    console.log(this.option);
    await this.checkIfRecordInProgress();
    const adviceTime = 10 * 60000;
    if (this.getAdviseTime(adviceTime) > 0) {
      setTimeout(this.showAdviseTime, this.getAdviseTime(adviceTime));
    }
    const RTCClient = (await import('~/assets/RTCClient.js')).default;
    this.rtc = new RTCClient();
    const rtc = this.rtc;
    rtc.on('stream-added', (evt) => {
      const { stream } = evt;
      log('[agora] [stream-added] stream-added', stream.getId());
      rtc.clientUser.subscribe(stream);
    });

    rtc.on('onTokenPrivilegeWillExpire', (evt) => {
      console.log('El token está próximo a expirar', evt);
      this.snackBar.color = 'error';
      this.snackBar.text = 'Faltan menos de 30 segundos para que la sesión finalice';
      this.snackBar.show = true;
    });

    rtc.on('onTokenPrivilegeDidExpire', (evt) => {
      this.leaveEvent();
      open(this.$config.ctAttentionUrl + '/paciente/cuestionario-postcita/' + this.appointmentInfo.id, '_blank');
      this.$router.push('/error/cita-terminada');
    });

    rtc.on('stream-subscribed', (evt) => {
      const { stream } = evt;
      log('[agora] [stream-subscribed] stream-added', stream.getId());
      if (!this.remoteStreams.find(it => it.getId() === stream.getId())) {
        this.remoteStreams.push(stream);
      }
    });

    rtc.on('stream-removed', (evt) => {
      const { stream } = evt;
      log('[agora] [stream-removed] stream-removed', stream.getId());
      this.remoteStreams = this.remoteStreams.filter(it => it.getId() !== stream.getId());
    });

    rtc.on('peer-online', (evt) => {
      console.log(evt);
    });

    rtc.on('peer-leave', (evt) => {
      this.remoteStreams = this.remoteStreams.filter(it => it.getId() !== evt.uid);
    });
    await this.setLoadingEntry({ loadingEntry: false });
    const video = document.getElementById('video');
    if (navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
      navigator.mediaDevices.getUserMedia({ video: true }).then(function (stream) {
        video.srcObject = stream;
        video.play();
      });
    }
    this.setTimer();
  },
  methods: {
    ...mapActions({
      getToken: 'videocalling/getToken',
      setChannel: 'videocalling/setChannel',
      enterVideoCallService: 'videocalling/enterVideoCallService',
      setResourceID: 'videocalling/setResourceID',
      setSID: 'videocalling/setSID',
      setResourceIDMix: 'videocalling/setResourceIDMix',
      setSIDMix: 'videocalling/setSIDMix',
      saveRecordingParameters: 'videocalling/saveRecordingParameters',
      obtainVideoCallSaveDirectory: 'videocalling/obtainVideoCallSaveDirectory',
      setLoadingEntry: 'videocalling/setLoadingEntry',
      setUserInformation: 'videocalling/setUserInformation',
      makeTranscription: 'videocalling/makeTranscription',
    }),
    joinEvent() {
      this.loadingBtnJoin = true;
      if (!this.option.appid) {
        this.judge('Appid');
        this.loadingBtnJoin = false;
        return;
      }
      if (!this.option.channel) {
        this.judge('Channel Name');
        this.loadingBtnJoin = false;
        return;
      }
      this.rtc.joinChannel(this.option).then(() => {
        this.rtc.publishStream().then((stream) => {
          this.localStream = stream;
          this.disableJoin = true;
          if (this.preMuteAudioBool) {
            this.muteAudio();
          }
          if (this.preMuteVideoBool) {
            this.muteVideo();
          }
          if (this.disableRecording) {
            this.snackBar.color = 'primary';
            this.snackBar.text = 'Grabación en curso';
            this.snackBar.show = true;
          }
          this.loadingBtnJoin = false;
          this.dialogPreVideoCall = false;
          this.snackBar.color = 'primary';
          this.snackBar.text = 'Ingreso al canal exitoso';
          this.snackBar.show = true;
        }).catch((err) => {
          log('publish local error', err);
          this.loadingBtnJoin = false;
          this.snackBar.color = 'error';
          this.snackBar.text = 'Ocurrió un error al ingresar a la videollamada, por favor, vuelva a intentarlo';
          this.snackBar.show = true;
        });
      }).catch((err) => {
        log('join channel error', err);
        this.loadingBtnJoin = false;
        this.snackBar.color = 'error';
        this.snackBar.text = 'Ocurrió un error al ingresar a la videollamada, por favor, vuelva a intentarlo';
        this.snackBar.show = true;
      });
    },
    leaveEvent() {
      this.disableJoin = false;
      this.rtc.leaveChannelUser().then(() => {
        console.log('Salida de canal con éxito');
        this.muteAudioBool = false;
        this.muteVideoBool = false;
        if (!this.user.userType) {
          this.dialogPoll = true;
        }
      }).catch((err) => {
        log('leave error', err);
      });
      this.localStream = null;
      this.remoteStreams = [];
    },
    judge(detail) {
      console.log(detail);
    },
    getAdviseTime(alertTime) {
      const endHour = new Date();
      const actualHour = new Date();
      endHour.setHours(this.appointmentInfo.endHour);
      endHour.setMinutes(this.appointmentInfo.endMinute);
      endHour.setSeconds(this.appointmentInfo.endSecond);
      const endHourSub = new Date(endHour.getTime() - alertTime);
      console.log(endHourSub.getTime() - actualHour.getTime());
      return endHourSub.getTime() - actualHour.getTime();
    },
    showAdviseTime() {
      this.snackBar.color = 'primary';
      this.snackBar.text = '10 minutos restantes';
      this.snackBar.show = true;
    },
    async checkIfRecordInProgress() {
      if (this.option.sid && this.option.resourceId && this.option.sidMix && this.option.resourceIdMix) {
        try {
          await this.statusRecording();
          this.queryInterval = setInterval(async () => { await this.statusRecording(); }, this.loopTimeMs);
          await this.statusRecordingMix();
          this.queryIntervalMix = setInterval(async () => { await this.statusRecordingMix(); }, this.loopTimeMs);
          this.disableRecording = true;
        } catch (error) {
          this.disableRecording = false;
        }
      }
    },
    async startVideoRecording() {
      this.loadingBtnRecording = true;
      if (this.optionRecorder.firstTime) {
        await this.rtc.joinChannelRecorder(this.option, this.optionRecorder);
      }
      await this.obtainVideoCallSaveDirectory({ videoCallId: this.option.videoCallId, token: this.user.token, role: this.user.userType });
      console.log(this.s3BucketInfo);
      await this.getResourceID();
      await this.getResourceIDMix();
      await this.startVideoRecordingAgora();
      await this.startVideoRecordingAgoraMix();
      await this.saveRecordingParameters({ resourceId: this.option.resourceId, sid: this.option.sid, videoCallId: this.option.videoCallId, firstTimeAgoraTokenRecorder: false, folderName: this.s3BucketInfo.saveDirectory, token: this.user.token, role: this.user.userType });
      await this.saveRecordingParameters({ resourceId: this.option.resourceIdMix, sid: this.option.sidMix, videoCallId: this.option.videoCallId, firstTimeAgoraTokenRecorder: false, folderName: this.s3BucketInfo.saveDirectoryMix, token: this.user.token, role: this.user.userType });
      // llamar otra vez a esta función para guardar los parámetros de la grabación mixta
      this.queryInterval = setInterval(async () => { await this.statusRecording(); }, this.loopTimeMs);
      this.queryIntervalMix = setInterval(async () => { await this.statusRecordingMix(); }, this.loopTimeMs);
      this.snackBar.color = 'primary';
      this.snackBar.text = 'Grabación iniciada exitosamente';
      this.snackBar.show = true;
      this.disableRecording = true;
      this.loadingBtnRecording = false;
    },
    async getResourceID() {
      const body = {
        cname: this.option.channel,
        uid: this.optionRecorder.uid,
        'clientRequest': {
        },
      };
      const token = this.optionRecorder.authToken;
      const url = 'https://api.agora.io/v1/apps/' + this.option.appid + '/cloud_recording/acquire';
      const header = {
        headers: {
          'Authorization': `Basic ${token}`,
        },
      };
      const res = await axios.post(url, body, header);
      await this.setResourceID({ resourceId: res.data.resourceId });
      console.log('resourceID: ', this.option.resourceId);
    },
    async getResourceIDMix() {
      const body = {
        cname: this.option.channel,
        uid: this.optionRecorder.uid,
        'clientRequest': {
        },
      };
      const token = this.optionRecorder.authToken;
      const url = 'https://api.agora.io/v1/apps/' + this.option.appid + '/cloud_recording/acquire';
      const header = {
        headers: {
          'Authorization': `Basic ${token}`,
        },
      };
      const res = await axios.post(url, body, header);
      await this.setResourceIDMix({ resourceId: res.data.resourceId });
      console.log('resourceID: ', this.option.resourceIdMix);
    },
    async statusRecording() {
      try {
        const token = this.optionRecorder.authToken;
        const url = 'https://api.agora.io/v1/apps/' + this.option.appid + '/cloud_recording/resourceid/' +
                  this.option.resourceId + '/sid/' + this.option.sid + '/mode/' + this.option.mode + '/query';
        const header = {
          headers: {
            'Authorization': `Basic ${token}`,
          },
        };
        const res = await axios.get(url, header);
        console.log(res);
      } catch (error) {
        this.disableRecording = false;
        if (this.queryInterval) {
          clearInterval(this.queryInterval);
        }
      }
    },
    async statusRecordingMix() {
      try {
        const token = this.optionRecorder.authToken;
        const url = 'https://api.agora.io/v1/apps/' + this.option.appid + '/cloud_recording/resourceid/' +
                  this.option.resourceIdMix + '/sid/' + this.option.sidMix + '/mode/' + this.option.modeMix + '/query';
        const header = {
          headers: {
            'Authorization': `Basic ${token}`,
          },
        };
        const res = await axios.get(url, header);
        console.log(res);
      } catch (error) {
        this.disableRecording = false;
        if (this.queryIntervalMix) {
          clearInterval(this.queryIntervalMix);
        }
      }
    },
    async startVideoRecordingAgora() {
      const body = {
        cname: this.option.channel,
        uid: this.optionRecorder.uid,
        'clientRequest': {
          'token': this.optionRecorder.agoraToken,
          'recordingConfig': {
            'maxIdleTime': 30,
            'streamTypes': 2,
            'channelType': 0,
            'videoStreamType': 1,
            'subscribeUidGroup': 1,
          },
          'storageConfig': {
            'accessKey': this.s3BucketInfo.accessKey,
            'region': 1,
            'bucket': this.s3BucketInfo.bucketName,
            'secretKey': this.s3BucketInfo.secretKey,
            'vendor': 1,
            'fileNamePrefix': [this.s3BucketInfo.saveDirectory],
          },
        },
      };
      const token = this.optionRecorder.authToken;
      const url = 'https://api.agora.io/v1/apps/' + this.option.appid +
                '/cloud_recording/resourceid/' + this.option.resourceId +
                '/mode/' + this.option.mode + '/start';
      const header = {
        headers: {
          'Authorization': `Basic ${token}`,
        },
      };
      const res = await axios.post(url, body, header);
      await this.setSID({ sid: res.data.sid });
      console.log('SID ', this.option.sid);
    },
    async startVideoRecordingAgoraMix() {
      const body = {
        cname: this.option.channel,
        uid: this.optionRecorder.uid,
        'clientRequest': {
          'token': this.optionRecorder.agoraToken,
          'recordingConfig': {
            'maxIdleTime': 30,
            'streamTypes': 2,
            'channelType': 0,
            'videoStreamType': 1,
            'subscribeUidGroup': 1,
            'transcodingConfig': {
              'height': 720,
              'width': 1280,
              'bitrate': 1130,
              'fps': 15,
              'mixedVideoLayout': 1,
            },
          },
          'recordingFileConfig': {
            'avFileType': ['hls', 'mp4'],
          },
          'storageConfig': {
            'accessKey': this.s3BucketInfo.accessKey,
            'region': 1,
            'bucket': this.s3BucketInfo.bucketName,
            'secretKey': this.s3BucketInfo.secretKey,
            'vendor': 1,
            'fileNamePrefix': [this.s3BucketInfo.saveDirectoryMix],
          },
        },
      };
      const token = this.optionRecorder.authToken;
      const url = 'https://api.agora.io/v1/apps/' + this.option.appid +
                '/cloud_recording/resourceid/' + this.option.resourceIdMix +
                '/mode/' + this.option.modeMix + '/start';
      const header = {
        headers: {
          'Authorization': `Basic ${token}`,
        },
      };
      const res = await axios.post(url, body, header);
      await this.setSIDMix({ sid: res.data.sid });
      console.log('SID ', this.option.sidMix);
    },
    async stopVideoRecording() {
      this.loadginBtnStopRecording = true;
      const body = {
        cname: this.option.channel,
        uid: this.optionRecorder.uid,
        'clientRequest': {
        },
      };
      const token = this.optionRecorder.authToken;
      const url = 'https://api.agora.io/v1/apps/' + this.option.appid + '/cloud_recording/resourceid/' +
      this.option.resourceId + '/sid/' + this.option.sid + '/mode/' + this.option.mode + '/stop';
      const header = {
        headers: {
          'Authorization': `Basic ${token}`,
        },
      };
      const res = await axios.post(url, body, header);
      console.log(res);
      await this.stopVideoRecordingMix();
      // Acá realizar el makeo de la transcripción
      setTimeout(this.sendOrderTranscription, 15000);
      this.disableRecording = false;
      clearInterval(this.queryInterval);
      this.loadginBtnStopRecording = false;
    },
    sendOrderTranscription() {
      const dir = this.s3BucketInfo.saveDirectory + '&' + this.s3BucketInfo.saveDirectoryMix;
      console.log(dir);
      this.makeTranscription({ appointmentId: this.appointmentInfo.id, userId: this.option.patientUid, videocallDir: dir, videocallUuid: this.user.userUUID, token: this.user.token, role: this.user.userType });
    },
    async stopVideoRecordingMix() {
      const body = {
        cname: this.option.channel,
        uid: this.optionRecorder.uid,
        'clientRequest': {
        },
      };
      const token = this.optionRecorder.authToken;
      const url = 'https://api.agora.io/v1/apps/' + this.option.appid + '/cloud_recording/resourceid/' +
      this.option.resourceIdMix + '/sid/' + this.option.sidMix + '/mode/' + this.option.modeMix + '/stop';
      const header = {
        headers: {
          'Authorization': `Basic ${token}`,
        },
      };
      const res = await axios.post(url, body, header);
      console.log(res);
    },
    muteAudio() {
      this.rtc.muteAudio();
      this.muteAudioBool = true;
    },
    muteVideo() {
      this.rtc.muteVideo();
      this.muteVideoBool = true;
    },
    unmuteAudio() {
      this.rtc.unmuteAudio();
      this.muteAudioBool = false;
    },
    unmuteVideo() {
      this.rtc.unmuteVideo();
      this.muteVideoBool = false;
    },
    preMuteAudio() {
      this.preMuteAudioBool = true;
    },
    preMuteVideo() {
      this.preMuteVideoBool = true;
      const video = document.getElementById('video');
      if (navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
        navigator.mediaDevices.getUserMedia({ video: true }).then(function () {
          video.srcObject = null;
        });
      }
    },
    preUnmuteAudio() {
      this.preMuteAudioBool = false;
    },
    preUnmuteVideo() {
      this.preMuteVideoBool = false;
      const video = document.getElementById('video');
      if (navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
        navigator.mediaDevices.getUserMedia({ video: true }).then(function (stream) {
          video.srcObject = stream;
          video.play();
        });
      }
    },
    startTimer(duration, display) {
      let timer = duration;
      let minutes;
      let seconds;
      setInterval(function () {
        minutes = parseInt(timer / 60, 10);
        seconds = parseInt(timer % 60, 10);

        minutes = minutes < 10 ? '0' + minutes : minutes;
        seconds = seconds < 10 ? '0' + seconds : seconds;

        display.textContent = minutes + ':' + seconds;

        if (--timer < 0) {
          display.textContent = '';
        }
      }, 1000);
    },
    setTimer() {
      const time = this.getAdviseTime(2000) / 1000;
      const display = document.querySelector('#time');
      this.startTimer(time, display);
    },
    openPollPacient() {
      open(this.$config.ctAttentionUrl + '/paciente/cuestionario-postcita/' + this.appointmentInfo.id, '_blank');
      this.dialogPoll = false;
    },
  },
};
</script>

<style scoped>
  .agora-title {
    font-family: Avenir, Helvetica, Arial, sans-serif;
    font-size: 32px;
    font-weight: bold;
    text-align: center;
    color: #2c3e50;
  }
  .agora-view {
    display: flex;
    flex-wrap: wrap;
  }
  .agora-video {
    width: 90%;
    height: 90%;
    margin: auto;
    margin-top: 4vh;
  }
  .agora-input {
    margin: 20px;
    width: 320px;
  }
  .agora-text {
    margin: 5px;
    font-size: 16px;
    font-weight: bold;
  }
  .agora-button {
    display: flex;
    width: 160px;
    justify-content: space-between;
    margin: 20px;
  }
  .bg {
    background-color: rgb(92, 87, 87);
  }
  .patient-class {
    min-height: 70vh;
    justify-content: center;
    align-items: center;
  }
  .bg-pre-video{
    background-color: rgb(199, 191, 191)
  }
  .pre-video{
    width: 500px;
    height: 375px;
    background-color: rgb(92, 87, 87);
  }
  .pre-sheet{
    width: 500px;
    height: 375px;
  }
  .name-class {
    min-height: 3vh;
    justify-content: center;
    align-items: center;
    padding: 0px;
  }
  .name-align {
    width: 40%;
    margin: auto;
    margin-bottom: 40px;
  }

</style>
